<template>
  <li class="promotion__item">
    <el-image
      class="promotion__image"
      :src="promotion.ImagePathForDisplay"
      lazy
    >
      <template #error>
        <div class="h-full bg-[var(--background1)]">
          <img :src="getAssetImage('assets/theme/common/game/NoImage.png')" />
        </div>
      </template>
    </el-image>
    <div class="promotion__info">
      <h3 class="promotion__title" :title="promotion.Title">
        {{ promotion.Title }}
      </h3>
      <div class="promotion__duration">
        <p class="promotion__duration__row">
          {{ $t('start_date') }}
          <span class="promotion__duration__time">{{
            promotion.StartDateForDisplay
          }}</span>
        </p>
        <p class="promotion__duration__row">
          {{ $t('end_date') }}
          <span class="promotion__duration__time">{{
            promotion.EndDateForDisplay
          }}</span>
        </p>
      </div>
      <p
        class="promotion__description"
        v-html="promotion.Content ? promotion.Content.slice(0, 200) : ''"
      ></p>
      <div class="promotion-stat">
        <div class="promotion__buttons">
          <button @click="openModal(promotion.Id)">
            <Button 
            :id="`${ID.PROMOTION_INFO}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
            variant="Accent">{{ $t("information") }}</Button>
          </button>
          <template v-if="promotion.PromotionTypeId === 10">
            <button
              v-if="validateLuckyWheelbutton"
              class="apply-button"
              @click="onClickSpinNow"
              :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
            >
              <Button variant="Accent" class="apply-button">
                <div class="flex items-center gap-2 pointer-events-none">
                  <span>{{ $t("Spin Now") }}</span>
                </div>
              </Button>
            </button>
          </template>
          <template v-else>
            <button
              v-if="isLoggedIn && shouldShowApplyButton"
              class="apply-button"
              :class="{ 'is-disabled': isProcessing }"
              :disabled="isProcessing"
              @click="applyPromotion"
            >
              <Button variant="Accent" class="apply-button" 
              :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
              >
                <div class="flex items-center gap-2 pointer-events-none">
                  <el-icon class="is-loading" v-if="isProcessing && isApplying">
                    <Loading />
                  </el-icon>
                  <span>{{ $t("apply") }}</span>
                </div>
              </Button>
            </button>
          </template>
        </div>
      </div>
    </div>
  </li>
</template>
<script setup lang="ts">
import { computed } from "vue";
import Button from "./ui/Button.client.vue";
import { Promotion } from "@/models/promotion/promotion";
import commonHelper from "@/utils/commonHelper";
import { store } from "@/store";
import { ElIcon } from "element-plus";
import { Loading } from "@element-plus/icons-vue";
import { ID } from "~~/utils/constants";

// const { onApplyPromotion, isProcessing, buttonApplyPromotionEnabled } =
//   usePromotion();
const isLoggedIn = computed(() => store.state.auth);
const { getAssetImage } = commonHelper;
const props = defineProps({
  promotion: {
    type: Object as PropType<Promotion>,
    required: true,
  },
  isApplying: {
    type: Boolean,
    default: false,
  },
  isProcessing: {
    type: Boolean,
    default: false,
  },
  shouldShowApplyButton: {
    type: Boolean,
    default: false,
  },
  onClickSpinNow: {
    type: Function,
    required: true,
  },
  validateLuckyWheelbutton: {
    type: Boolean,
    required: true,
  },
});
const emit = defineEmits(["open", "apply"]);

const openModal = (id: number) => {
  emit("open", id);
};
const applyPromotion = () => {
  if (!props.promotion) return;
  emit('apply');
}
</script>

<style scoped>
button.apply-button.is-disabled .apply-button {
  cursor: not-allowed;
}
button.apply-button.is-disabled .apply-button {

}
.promotion__item {
  display: flex;
  background-color: var(--background2);
  border-radius: 16px;
  border: 2px solid var(--element-border-color);
  overflow: hidden;
  margin-bottom: 32px;
  box-shadow: var(--box-shadow);
  color: var(--font-color-primary);
}

@media (max-width: 980px) {
  .promotion__item {
    flex-direction: column;
    width: calc(50% - 16px);
  }
}

@media (max-width: 767px) {
  .promotion__item {
    width: 100%;
  }
}

.promotion__image {
  width: 100%;
}

.promotion__item .promotion__image {
  position: relative;
  width: 640px;
  padding: 0;
  overflow: hidden;
}

@media (max-width: 980px) {
  .promotion__item .promotion__image {
    padding-bottom: 67%;
    width: 100%;
    max-width: 100%;
  }
}

:deep(.promotion__image img) {
  position: absolute;
  top: 0;
  left: 0;
  height: 100%;
  width: 100%;
  object-fit: contain;
  object-position: center;
}

.promotion__info {
  position: relative;
  z-index: 1;
  width: 50%;
  padding: 26px 40px 34px;
}

@media (max-width: 1440px), (orientation: portrait) {
  .promotion__info {
    padding: 10px 15px;
  }
}

@media (max-width: 980px) {
  .promotion__info {
    width: 100%;
  }
}

.promotion__title {
  font-size: 24px;
  font-weight: bold;
  line-height: 1.5;
  color: var(--title-font-color);
  user-select: none;
  margin-bottom: 25px;
  overflow: hidden;
  text-overflow: ellipsis;
  display: -webkit-box;
  -webkit-line-clamp: 1;
  line-clamp: 1;
  -webkit-box-orient: vertical;
}

@media (max-width: 768px) {
  .promotion__item .promotion__title {
    font-size: 18px;
  }
}

.promotion__duration {
  margin-bottom: 20px;
}
.promotion__duration__row {
  margin-bottom: 20px;
}
.promotion__duration__row:not(:last-of-type) {
  margin-bottom: 10px;
}

.promotion__duration__row span {
  color: var(--title-font-color);
  font-weight: bold;
  margin: 0 10px;
}

.promotion__description {
  margin-bottom: 16px;
  font-size: 16px;
  line-height: 1.5;
  text-align: left;
  overflow: hidden;
  text-overflow: ellipsis;
  display: -webkit-box;
  -webkit-line-clamp: 2;
  line-clamp: 2;
  -webkit-box-orient: vertical;
}

@media (max-width: 768px) {
  .promotion__item .promotion__description {
    font-size: 14px;
    line-height: 20px;
  }
}

.promotion-stat {
  display: flex;
  align-items: center;
  justify-content: space-between;
  flex-wrap: wrap;
  margin-bottom: 0.5rem;
}

@media (max-width: 1220px) {
  .promotion__item .promotion-stat {
    flex-direction: column;
    align-items: flex-start;
  }
}

.promotion__buttons {
  display: flex;
  gap: 0.5rem;
  justify-content: space-between;
}

@media (max-width: 767px) {
  .promotion__buttons {
    justify-content: flex-start;
  }
}

@media (max-width: 1220px) {
  .promotion__item .promotion__buttons {
    margin-top: 16px;
  }
}
</style>
<style lang="scss">
[layout="modern"] {
  .page__promotion {
    .el-overlay, .el-overlay-dialog {
      position: unset;
    }
  }
}
</style>